# Neural DNF

This repo contains the code for the paper <Neural Disjunctive Normal Form>


The current implementation involves many ad-hoc solutions to fix bugs.


## Demo
Demo on MNIST can be reproduced by the demo `Demo-Experiment-MNIST.ipynb`.

## Experiments
* The 2d-XOR dataset can be reproduced in the `Experiment-2d Example.ipynb`
* The experiments on several image datasets is in  `Neural DNF Run on multiple datasets.ipynb` and `Neural DNF Test on multiple datasets.ipynb`. The latter is for evaluation. (including the computation of faithfulness)
* The experiment for the Boolean synthetic dataset where we learn DNF alone is in `Experiment-Boolean Synthetic.ipynb`

## Code
The code is based on a mixture of multiple open sourced implementation.

* [JointVAE](https://github.com/Schlumberger/joint-vae) **Learning Disentangled Joint Continuous and Discrete Representations**, NeurIPS 2018
* [MLLP](https://github.com/12wang3/mllp) **Transparent Classification with Multilayer Logical Perceptrons and Random Binarization**, AAAI 2020
* **Towards Robust Interpretability with Self-Explaining Neural Networks**, NeurIPS 2018

## Requirements

* torch>=1.0.1
* torchvision>=0.2.2
* sklearn>=0.21.2
* numpy>=1.16.3
* pandas>=0.24.2
* matplotlib>=3.0.0
* CUDA (optional, for running on GPU)
* pytorch-Lightning == 0.7.6 (there are new improvements in the new version)
* captum: which for the evaluation (the post-hoc interpretation methods)

## DataSet

For some datasets, you need do manual download and maybe do some renaming of file. Specification can be found at `dataloaders.py`

## License

[MIT license](LICENSE)
